﻿Imports VBTablet.Tablet

Class Canvas : Implements Api.Canvas
    Dim _queue As Queue = New Queue
    Dim _invoker As Api.Invoker
    Dim _location As Point
    Dim _pressure As Double
    Dim _paLocation As Point
    Dim _paNormalPressure As Double
    Dim _pa As Boolean = False

    Dim WithEvents _vbTablet As VBTablet.Tablet

    Public Sub PacketArrival(ByRef ContextHandle As System.IntPtr, ByRef Cursor As Integer, ByRef X As Integer, ByRef Y As Integer, ByRef Z As Integer, ByRef Buttons As Integer, ByRef NormalPressure As Integer, ByRef TangentPressure As Integer, ByRef Azimuth As Integer, ByRef Altitude As Integer, ByRef Twist As Integer, ByRef Pitch As Integer, ByRef Roll As Integer, ByRef Yaw As Integer, ByRef PacketSerial As Integer, ByRef PacketTime As Integer) Handles _vbTablet.PacketArrival
        If NormalPressure > 0 Then
            Me._paLocation = Me.PointToClient(New Point(X, Screen.PrimaryScreen.Bounds.Height - Y))
            Me._paNormalPressure = NormalPressure / 1024
            Me._pa = True
        Else
            Me._paLocation = Point.Empty
            Me._paNormalPressure = 0
            Me._pa = False
        End If
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e1 As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        Me._invoker = New DrawFreehandLine(Tablet.Instance(MainForm.TabletName))
        Me._invoker.Canvas = Me
        Me._location = IIf(Me._pa, Me._paLocation, e1.Location)
        Me._pressure = IIf(Me._pa, Me._paNormalPressure, 256 / 1024)
    End Sub

    Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
        If e.Button <> Windows.Forms.MouseButtons.None AndAlso Me._location <> Point.Empty Then
            If Me._pa Then
                Me._invoker.AddStrokePointPair(New StrokePointPair(New StrokePoint(Me._location, Me._pressure), New StrokePoint(Me._paLocation, Me._paNormalPressure)))
                Me._location = Me._paLocation
                Me._pressure = Me._paNormalPressure
            Else
                Me._invoker.AddStrokePointPair(New StrokePointPair(New StrokePoint(Me._location, Me._pressure), New StrokePoint(e.Location, Me._pressure)))
                Me._location = e.Location
                Me._pressure = Me._pressure
            End If
            Me._queue.Enqueue(Me._invoker)
        End If
    End Sub

    Private Sub PictureBox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp
        If Me._pa Then
            Me._invoker.AddStrokePointPair(New StrokePointPair(New StrokePoint(Me._location, Me._pressure), New StrokePoint(Me._paLocation, Me._paNormalPressure)))
        Else
            Me._invoker.AddStrokePointPair(New StrokePointPair(New StrokePoint(Me._location, Me._pressure), New StrokePoint(e.Location, Me._pressure)))
        End If
        Me._queue.Enqueue(Me._invoker)
        Me._location = Nothing
        Me._pressure = 0
    End Sub

    Public ReadOnly Property Image() As Image Implements Api.Canvas.Image
        Get
            Image = Me.PictureBox1.Image
        End Get
    End Property

    Public Sub Draw(ByVal i As System.Drawing.Image, ByVal location As System.Drawing.Point) Implements Api.Canvas.Draw
        Dim g = Me.PictureBox1.CreateGraphics()
        g.DrawImage(i, location)
        g.Dispose()
        Me.Invalidate()
    End Sub

    Sub New()

        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

        Me._vbTablet = New VBTablet.Tablet()
        With Me._vbTablet
            .hWnd = Me.Handle.ToInt32()
            .Connected = True
            .Context.Enabled = True
            .Context.Update()
            .Context.QueueSize = 4
        End With

        ' UNDONE:
        Me.PictureBox1.Image = New Bitmap(1000, 1000)
    End Sub

    Private Sub Canvas_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
        Me._vbTablet.Connected = False
    End Sub
End Class
