﻿Class Queue
    Dim _invokers As Queue(Of Api.Invoker)
    Dim _timer As System.Threading.Timer
    Dim _lock As Threading.ReaderWriterLockSlim = New Threading.ReaderWriterLockSlim

    Sub Enqueue(ByVal e As Api.Invoker)
        With Me._lock
            .EnterWriteLock()
            Me._invokers.Enqueue(e)
            .ExitWriteLock()
        End With
    End Sub

    Sub Timer(ByVal state As Object)
        With Me._lock
            .EnterUpgradeableReadLock()
            If Me._invokers.Count > 0 Then
                .EnterWriteLock()
                Do While Me._invokers.Count > 0
                    Me._invokers.Dequeue().Invoke()
                Loop
                .ExitWriteLock()
            End If
            .ExitUpgradeableReadLock()
        End With
        Me._timer.Change(1, Threading.Timeout.Infinite)
    End Sub

    Sub New()
        Me._invokers = New Queue(Of Api.Invoker)
        Me._timer = New System.Threading.Timer(AddressOf Me.Timer, Nothing, 1, Threading.Timeout.Infinite)
    End Sub

End Class
